/////////////////////////////////////////////////////////////////////////////
// tObjectList.h : interface for the CtObjectList class.
// As part of the Undo_Redo_Demo application
// By Tom Morris of trilobiteWorks. December 2002
// Use freely...

#pragma once

#include "stdafx.h"


//	NOTE: This is a list template with only a single override function (Serialize())
//	The serialize function will only work with classes descended from CObject.
//	You may have to override other CList functions depending on the Class types
//	you are handling.

//////////////////////////////////////////////////////////////////////////////
template <class TYPE, class ARG_TYPE>
class CtObjectList : public CList<TYPE, ARG_TYPE>
{
// Construction
public:
	CtObjectList(const CtObjectList &temp) { (*this) = temp; }
	CtObjectList<TYPE, ARG_TYPE>() {};
	CtObjectList<TYPE, ARG_TYPE>& operator = (const CtObjectList &temp);
	void Serialize(CArchive &ar);
	virtual ~CtObjectList<TYPE, ARG_TYPE>() {};

// Attributes
public:

private:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CtObjectList)
	//}}AFX_VIRTUAL

// Implementation
public:

	// Generated message map functions
protected:
	//{{AFX_MSG(CtObjectList)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	//	DECLARE_MESSAGE_MAP()
};


template<class TYPE, class ARG_TYPE>
inline 	CtObjectList<TYPE, ARG_TYPE>& CtObjectList<TYPE, ARG_TYPE>::operator=(const CtObjectList<TYPE, ARG_TYPE> &temp) 
{

	ASSERT_VALID(this);
	if (this == &temp)
		return *this;

	CtObjectList<TYPE, ARG_TYPE>::RemoveAll();

	POSITION pos = NULL;
	pos = temp.GetHeadPosition();

	while (pos)
	{
		TYPE	tempObject;
		
		tempObject = temp.GetNext(pos);
		
		CtObjectList<TYPE, ARG_TYPE>::AddTail(tempObject);
	}

	return *this;
}



template<class TYPE, class ARG_TYPE>
inline void CtObjectList<TYPE, ARG_TYPE>::Serialize(CArchive &ar)
{
	ASSERT_VALID(this);

	CObject::Serialize(ar);

	if (ar.IsStoring())
	{
		ar.WriteCount(m_nCount);
		for (CNode* pNode = m_pNodeHead; pNode != NULL; pNode = pNode->pNext)
		{
			ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
			pNode->data.Serialize(ar);
//			SerializeElements<TYPE>(ar, &pNode->data, 1);
		}
	}
	else
	{
		DWORD_PTR nNewCount = ar.ReadCount();
		while (nNewCount--)
		{
			TYPE	newData;
			newData.Serialize(ar);
//			SerializeElements<TYPE>(ar, &newData, 1);
			AddTail(newData);
		}
	}
}

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

